;------------------------------------------------------------------------------------------
; EMS VCS3 / Synthi A Emulator by Steven Cook - stevencook@appleonline.net
;------------------------------------------------------------------------------------------
f1 0 4097 7 0 4096 1                      ; + Ramp
f2 0 4097 7 -1 2048 1 2048 -1             ; Triangle
f3 0 4097 7 1 2048 1 0 -1 2048 -1         ; Square
f4 0 4097 -9 .5 1 270                     ; Rising Sigmoid for sine shaper
f5 0 8193 7 0 2048 1 2048 1 2048 0 2048 0 ; Trapezoid
f7 0 8193 -5 .5 8192 16384                ; Exponential curve for oscillator frequency
f8 0 8193 -5 5 8192 10000                 ; Exponential curve for filter frequency
t 0 15 ; Adjust tempo to vary output duration
;------------------------------------------------------------------------------------------
;OSCILLATOR 1   freq   shape  sine   saw
i1  0   1       7.000  0.52   0.75   0.10
;OSCILLATOR 2   freq   shape  pulse  ramp   sync
i2  0   1       1.000  0.00   0.75   0.60   0
;OSCILLATOR 3   freq   shape  pulse  ramp   sync   lfo
i3  0   1       3.050  0.33   0.00   0.25   0      1
;NOISE          color  level
i4  0   1       0.40   0.75
;INPUT          level  level
;i5 0   1       1.00   1.00
;FILTER         freq   resp   level
i6  0   1       0.50   0.90   0.50
;ENVELOPE       attack on     decay  off    trap   signal
i10 0   1       0.25   0.00   7.75   1.00   0.66   1.00
;RING MOD       level
i7  0   1       0.66
;REVERBERATION  mix    level
i8  0   1       1.00   0.50
;JOYSTICK       rangeX rangeY rateX  rateY
i9  0   1       0.10   0.10   1.33   2.77
;OUTPUT         level1 pan1   pan2   level2 color1 color2
i99 0   1       0.70   0.00   1.00   0.70   0.50   0.50
;------------------------------------------------------------------------------------------
;          |---------signal inputs---------|--------control inputs---------|
;          | m |       | e |       | r | f |           | d | r | f |       |
;          | e |       | n |       | e | i |           | e | e | i |       |
;          | t |       | v |       | v | l |           | c | v | l | o u t-|
;          | e | o u t-| e |r i n g| e | t |   o s c.  | a | e | t | p u t |
;          | r | p u t | o | m o d | r | e |  f r e q  | y | r | e |  c h  |
;          |   | c h   | p |       | b | r |           |   | b | r |le v el|
;          |   |       | e |       |   |   |           |   |   |   |       |
;          |   |       |   |       |   |   |           |   | m | f |       |
;          |   |       |   |       |   |   |           |   | i | r |       |
;          |   | 1   2 |   | A   B |   |   | 1   2   3 |   | x | q | 1   2 |
;----------+-^---^---^---^---^---^---^---^-+-^---^---^---^---^---^---^---^-+---------------
i98 0 1 01   0   1   1   0   1   0   0   0   0   0   0   0   0   0   0   0 ; sine
;          |                               |                               |   oscillator 1
i98 0 1 02   0   0   0   0   0   0   0   0   0   1   0   0   0   0   0   0 ; saw
;          |                               |                               |---------------
i98 0 1 03   0   0   0   0   0   1   0   0   0   0   0   0   0   0   0   0 ; pulse
;          |                               |                               |   oscillator 2
i98 0 1 04   0   0   0   1   0   0   0   0   0   0   0   0   0   0   0   0 ; /\
;          |                               |                               |---------------
i98 0 1 05   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0 ; pulse
;          |                               |                               |   oscillator 3
i98 0 1 06   0   0   0   0   0   0   0   0   0   0   0   0   0   1   0   0 ; /\
;          |                               |                               |---------------
i98 0 1 07   0   0   0   0   0   0   0   1   0   0   0   0   0   0   0   0 ; noise
;          |                               |                               |---------------
i98 0 1 08   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0 ; 1
;          |-------------------------------+-------------------------------|   input
i98 0 1 09   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0 ; 2
;          |                               |                               |---------------
i98 0 1 10   0   1   0   0   0   0   1   0   0   0   0   0   0   0   0   0 ; filter
;          |                               |                               |---------------
i98 0 1 11   0   0   0   0   0   0   0   0   0   1   0   0   0   0   0   0 ; trapezoid
;          |                               |                               |---------------
i98 0 1 12   0   0   0   0   0   0   0   0   1   0   0   0   0   0   0   0 ; env signal
;          |                               |                               |---------------
i98 0 1 13   0   0   0   0   0   0   0   1   0   0   0   0   0   0   0   0 ; ring mod
;          |                               |                               |---------------
i98 0 1 14   0   0   1   0   0   0   0   0   0   0   0   0   0   0   0   0 ; reverb
;          |                               |                               |---------------
i98 0 1 15   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0 ; X
;          |                               |                               |   joystick
i98 0 1 16   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0   0 ; Y
;----------+-------------------------------+-------------------------------+---------------